Subject: bug#8492: 23.3; Time to use a different binding for completion?

From: "Drew Adams" <[email-masked]>
Date: Sun, 24 Apr 2011 12:43:03 -0700

> > TAB can do completion if you (setq tab-always-indent 'complete).
> 
> I tried this out some time ago, but found it unsatisfactory.  The
> problem was that I sometimes spuriously triggered completion 
> when I only intended to indent, because the current line happened
> to be correctly indented.  It is often difficult to tell by eye
> whether a line is already indented.

Amen.  Another case of DWIM making the user work harder, forcing her to try to
second-guess it and figure out whether it will in fact DTRT in the current
context.  As I said:

>> Keep it simple.  Find a key or let users find their own key 
>> for a simple, straightforward command (i.e., that does only
>> what M-TAB does currently).  Forget about combining 36
>> different behaviors on the same key.
...
>> But please do not redesign the behavior to become hydra-headed
>> so it tries to adapt to multiple contexts, just because you
>> cannot think of a good default key.  That makes little sense.
>> 
>> And TAB, in particular, is *not* "the way forward for this".  
>> If ever there was a key *not* to double-up on for this (triple?
>> quadruple? pentuple?), TAB is it.  It's just about the poorest
>> choice possible here.

Simple, straightforward commands/keys give the user control (not the clever
programmer).